diff --git a/fftools/ffmpeg.c b/fftools/ffmpeg.c
index 01f04103cf..2f4229a9d0 100644
--- a/fftools/ffmpeg.c
+++ b/fftools/ffmpeg.c
@@ -2126,6 +2126,19 @@ static int ifilter_has_all_input_formats(FilterGraph *fg)
     return 1;
 }
 
+static int orientation_need_update(InputFilter *ifilter, AVFrame *frame)
+{
+    int orientaion = get_frame_orientation(frame);
+    int filterst = ifilter->orientation <= 1 ? 0 : // not set
+                   ifilter->orientation <= 4 ? 1 : // auto flip
+                   2; // auto transpose
+    int framest = orientaion <= 1 ? 0 : // not set
+                  orientaion <= 4 ? 1 : // auto flip
+                  2; // auto transpose
+
+    return filterst != framest;
+}
+
 static int ifilter_send_frame(InputFilter *ifilter, AVFrame *frame)
 {
     FilterGraph *fg = ifilter->graph;
@@ -2142,7 +2155,8 @@ static int ifilter_send_frame(InputFilter *ifilter, AVFrame *frame)
         break;
     case AVMEDIA_TYPE_VIDEO:
         need_reinit |= ifilter->width  != frame->width ||
-                       ifilter->height != frame->height;
+                       ifilter->height != frame->height ||
+                       orientation_need_update(ifilter, frame);
         break;
     }
 
diff --git a/fftools/ffmpeg.h b/fftools/ffmpeg.h
index 7b6f802082..64278b6ab1 100644
--- a/fftools/ffmpeg.h
+++ b/fftools/ffmpeg.h
@@ -244,7 +244,7 @@ typedef struct InputFilter {
     // parameters configured for this input
     int format;
 
-    int width, height;
+    int width, height, orientation;
     AVRational sample_aspect_ratio;
 
     int sample_rate;
@@ -649,6 +649,7 @@ int init_complex_filtergraph(FilterGraph *fg);
 void sub2video_update(InputStream *ist, AVSubtitle *sub);
 
 int ifilter_parameters_from_frame(InputFilter *ifilter, const AVFrame *frame);
+int get_frame_orientation(const AVFrame* frame);
 
 int ffmpeg_parse_options(int argc, char **argv);
 
diff --git a/fftools/ffmpeg_filter.c b/fftools/ffmpeg_filter.c
index 72838de1e2..1fcadb1871 100644
--- a/fftools/ffmpeg_filter.c
+++ b/fftools/ffmpeg_filter.c
@@ -743,6 +743,18 @@ static int sub2video_prepare(InputStream *ist, InputFilter *ifilter)
     return 0;
 }
 
+int get_frame_orientation(const AVFrame *frame)
+{
+    AVDictionaryEntry *entry = NULL;
+    int orientation = 0;
+    
+    // read exif orientation data
+    entry = av_dict_get(frame->metadata, "Orientation", NULL, 0);
+    if (entry && entry->value)
+        orientation = atoi(entry->value);
+    return orientation;
+}
+
 static int configure_input_video_filter(FilterGraph *fg, InputFilter *ifilter,
                                         AVFilterInOut *in)
 {
@@ -809,13 +821,18 @@ static int configure_input_video_filter(FilterGraph *fg, InputFilter *ifilter,
     if (ist->autorotate) {
         double theta = get_rotation(ist->st);
 
-        if (fabs(theta - 90) < 1.0) {
+        if (fabs(theta) < 1.0) { // no rotation info in stream meta
+            if (ifilter->orientation < 0 || ifilter->orientation > 8) {
+                av_log(NULL, AV_LOG_ERROR, "Invalid frame orientation: %i\n", ifilter->orientation);
+            } else if (ifilter->orientation > 1 && ifilter->orientation <= 4) { // skip 0 (not set) and 1 (orientaion 'Normal') 
+                ret = insert_filter(&last_filter, &pad_idx, "transpose", "orientation=auto_flip");
+            } else if (ifilter->orientation > 4) {
+                ret = insert_filter(&last_filter, &pad_idx, "transpose", "orientation=auto_transpose");
+            }
+        } else if (fabs(theta - 90) < 1.0) {
             ret = insert_filter(&last_filter, &pad_idx, "transpose", "clock");
         } else if (fabs(theta - 180) < 1.0) {
-            ret = insert_filter(&last_filter, &pad_idx, "hflip", NULL);
-            if (ret < 0)
-                return ret;
-            ret = insert_filter(&last_filter, &pad_idx, "vflip", NULL);
+            ret = insert_filter(&last_filter, &pad_idx, "transpose", "orientation=rotate180");
         } else if (fabs(theta - 270) < 1.0) {
             ret = insert_filter(&last_filter, &pad_idx, "transpose", "cclock");
         } else if (fabs(theta) > 1.0) {
@@ -1191,6 +1208,7 @@ int ifilter_parameters_from_frame(InputFilter *ifilter, const AVFrame *frame)
     ifilter->width               = frame->width;
     ifilter->height              = frame->height;
     ifilter->sample_aspect_ratio = frame->sample_aspect_ratio;
+    ifilter->orientation         = get_frame_orientation(frame);
 
     ifilter->sample_rate         = frame->sample_rate;
     ifilter->channels            = frame->channels;