diff --git a/fftools/ffmpeg.c b/fftools/ffmpeg.c
index 01f04103cf..bc0cece59d 100644
--- a/fftools/ffmpeg.c
+++ b/fftools/ffmpeg.c
@@ -2141,8 +2141,9 @@ static int ifilter_send_frame(InputFilter *ifilter, AVFrame *frame)
                        ifilter->channel_layout != frame->channel_layout;
         break;
     case AVMEDIA_TYPE_VIDEO:
-        need_reinit |= ifilter->width  != frame->width ||
-                       ifilter->height != frame->height;
+        need_reinit |= ifilter->width       != frame->width ||
+                       ifilter->height      != frame->height ||
+                       ifilter->orientation != get_frame_orientation(frame);
         break;
     }
 
diff --git a/fftools/ffmpeg.h b/fftools/ffmpeg.h
index 7b6f802082..7324813ce3 100644
--- a/fftools/ffmpeg.h
+++ b/fftools/ffmpeg.h
@@ -232,6 +232,12 @@ typedef struct OptionsContext {
     int        nb_enc_time_bases;
 } OptionsContext;
 
+enum OrientationType {
+    ORIENTATION_NONE,
+    ORIENTATION_AUTO_FLIP,
+    ORIENTATION_AUTO_TRANSPOSE
+};
+
 typedef struct InputFilter {
     AVFilterContext    *filter;
     struct InputStream *ist;
@@ -245,6 +251,7 @@ typedef struct InputFilter {
     int format;
 
     int width, height;
+    enum OrientationType orientation;
     AVRational sample_aspect_ratio;
 
     int sample_rate;
@@ -649,6 +656,7 @@ int init_complex_filtergraph(FilterGraph *fg);
 void sub2video_update(InputStream *ist, AVSubtitle *sub);
 
 int ifilter_parameters_from_frame(InputFilter *ifilter, const AVFrame *frame);
+enum OrientationType get_frame_orientation(const AVFrame* frame);
 
 int ffmpeg_parse_options(int argc, char **argv);
 
diff --git a/fftools/ffmpeg_filter.c b/fftools/ffmpeg_filter.c
index 72838de1e2..8fe17c8013 100644
--- a/fftools/ffmpeg_filter.c
+++ b/fftools/ffmpeg_filter.c
@@ -743,6 +743,32 @@ static int sub2video_prepare(InputStream *ist, InputFilter *ifilter)
     return 0;
 }
 
+enum OrientationType get_frame_orientation(const AVFrame *frame)
+{
+    AVDictionaryEntry *entry = NULL;
+    int orientation = 0;
+
+    // read exif orientation data
+    entry = av_dict_get(frame->metadata, "Orientation", NULL, 0);
+    if (entry && entry->value)
+        orientation = atoi(entry->value);
+
+    //exif defines orientation in range [1, 8]
+    if (orientation > 8 || orientation < 1) {
+        if (entry && entry->value) {
+            av_log(NULL, AV_LOG_WARNING,
+                "Invalid frame orientation: %s, skip it.\n", entry->value);
+        }
+        return ORIENTATION_NONE;
+    } else if (orientation == 1) {
+        return ORIENTATION_NONE;
+    } else if (orientation <= 4) {
+        return ORIENTATION_AUTO_FLIP;
+    } else {
+        return ORIENTATION_AUTO_TRANSPOSE;
+    }
+}
+
 static int configure_input_video_filter(FilterGraph *fg, InputFilter *ifilter,
                                         AVFilterInOut *in)
 {
@@ -809,13 +835,16 @@ static int configure_input_video_filter(FilterGraph *fg, InputFilter *ifilter,
     if (ist->autorotate) {
         double theta = get_rotation(ist->st);
 
-        if (fabs(theta - 90) < 1.0) {
+        if (fabs(theta) < 1.0) { // no rotation info in stream meta
+            if (ifilter->orientation == ORIENTATION_AUTO_FLIP) { 
+                ret = insert_filter(&last_filter, &pad_idx, "transpose", "orientation=auto_flip");
+            } else if (ifilter->orientation == ORIENTATION_AUTO_TRANSPOSE) {
+                ret = insert_filter(&last_filter, &pad_idx, "transpose", "orientation=auto_transpose");
+            }
+        } else if (fabs(theta - 90) < 1.0) {
             ret = insert_filter(&last_filter, &pad_idx, "transpose", "clock");
         } else if (fabs(theta - 180) < 1.0) {
-            ret = insert_filter(&last_filter, &pad_idx, "hflip", NULL);
-            if (ret < 0)
-                return ret;
-            ret = insert_filter(&last_filter, &pad_idx, "vflip", NULL);
+            ret = insert_filter(&last_filter, &pad_idx, "transpose", "orientation=rotate180");
         } else if (fabs(theta - 270) < 1.0) {
             ret = insert_filter(&last_filter, &pad_idx, "transpose", "cclock");
         } else if (fabs(theta) > 1.0) {
@@ -1191,6 +1220,7 @@ int ifilter_parameters_from_frame(InputFilter *ifilter, const AVFrame *frame)
     ifilter->width               = frame->width;
     ifilter->height              = frame->height;
     ifilter->sample_aspect_ratio = frame->sample_aspect_ratio;
+    ifilter->orientation         = get_frame_orientation(frame);
 
     ifilter->sample_rate         = frame->sample_rate;
     ifilter->channels            = frame->channels;